from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, File, String

Biscuit_Epiread_V0_1_0 = CommandToolBuilder(tool="biscuit_epiread", base_command=["biscuit", "epiread"], inputs=[ToolInput(tag="in_bed_input_snp", input_type=Boolean(optional=True), prefix="-B", doc=InputDocumentation(doc="bed input for SNP display in epiread output [no SNP]")), ToolInput(tag="in_region_optional_specified", input_type=Boolean(optional=True), prefix="-g", doc=InputDocumentation(doc="region (optional, if not specified the whole bam will be processed).")), ToolInput(tag="in_step_window_dispatching", input_type=Boolean(optional=True), prefix="-s", doc=InputDocumentation(doc="step of window dispatching [100000].")), ToolInput(tag="in_number_of_threads", input_type=Boolean(optional=True), prefix="-q", doc=InputDocumentation(doc="number of threads [3].")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="-o", doc=InputDocumentation(doc="output file [stdout]")), ToolInput(tag="in_pairwise_mode", input_type=Boolean(optional=True), prefix="-P", doc=InputDocumentation(doc="pairwise mode [off]")), ToolInput(tag="in_nomeseq_mode", input_type=Boolean(optional=True), prefix="-N", doc=InputDocumentation(doc="NOMe-seq mode [off]")), ToolInput(tag="in_verbose_print_additional", input_type=Boolean(optional=True), prefix="-v", doc=InputDocumentation(doc="verbose (print additional info for diagnosis).")), ToolInput(tag="in_minimum_mapping_quality", input_type=Boolean(optional=True), prefix="-m", doc=InputDocumentation(doc="minimum mapping quality [40].")), ToolInput(tag="in_max_cytosine_retention", input_type=Boolean(optional=True), prefix="-t", doc=InputDocumentation(doc="max cytosine retention in a read [999999].")), ToolInput(tag="in_minimum_read_length", input_type=Boolean(optional=True), prefix="-l", doc=InputDocumentation(doc="minimum read length [10].")), ToolInput(tag="in_filtering_secondary_mapping", input_type=Boolean(optional=True), prefix="-c", doc=InputDocumentation(doc="NO filtering secondary mapping.")), ToolInput(tag="in_no_filtering_duplicate", input_type=Boolean(optional=True), prefix="-u", doc=InputDocumentation(doc="NO filtering of duplicate.")), ToolInput(tag="in_filtering_improper_bamfproperpair", input_type=Boolean(optional=True), prefix="-p", doc=InputDocumentation(doc="NO filtering of improper pair (!BAM_FPROPER_PAIR).")), ToolInput(tag="in_maximum_nm_tag", input_type=Boolean(optional=True), prefix="-n", doc=InputDocumentation(doc="maximum NM tag [999999].")), ToolInput(tag="in_epi_read", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_ref_dot_fa", input_type=String(optional=True), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_in_dot_bam", input_type=String(optional=True), position=2, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="output file [stdout]"))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Biscuit_Epiread_V0_1_0().translate("wdl", allow_empty_container=True)

